/*****************************************************
* Lb`^C}vO
*  I2CC^[tF[XLCDڑ
*  HI-TECH Cgp
******************************************************/
#include  <htc.h>
#include  "lcd_i2c_lib.h"
#include  "i2c_lib1.h"
/***** RtBM[V̐ݒ ********/
__CONFIG(INTIO & WDTDIS & PWRTEN & BOREN & MCLREN
		& UNPROTECT & IESODIS & FCMDIS);
/** O[oϐ` **/
unsigned char Flag, State, Item;
unsigned char Flag1, Sec1, Min1, Flag2, Sec2, Min2;
unsigned char Msg1[] = "Timer1 XX:XX Off";
unsigned char Msg2[] = "Timer2 xx:xx Off";
/** ֐vg^CsO **/
void itostring(char digit, unsigned int data, char *buffer);
void Display(void);
void Buzzer(unsigned cont);
void Cursor(unsigned char item);
void Process(void);
/************* C֐  ******************/
void main(void)
{
	OSCCON = 0x40;					// Set to 1MHz
	TRISIO = 0x38;					// GP3,4,5͐ݒ
	ANSEL = 0x00;						// SfW^ɐݒ
	CMCON0 = 0x07;					// Rp[^It
	GPPU   = 0;						// vAbvL
	WPU    = 0x30;					// GP4,5vAbvw
	/* t\̏  */
	lcd_init();
	lcd_str("Start My Timer! ");
	/* Timer1ݒ 1b **/
	T1CON = 0x30;						// NbNA1/8 4usec 
	TMR1H = 0x85;						// TMR1ʃZbg
	TMR1L = 0xF0;						// TMR1ʃZbg
	TMR1IE = 1;						// 荞݋
	TMR1ON = 1;						// ^C}PX^[g
	/* 荞݋ */
	PEIE   = 1;
	GIE    = 1;
	/* ϐ */
	Sec1 = 0;
	Min1 = 0;
	Sec2 = 0;
	Min2 = 0;
	Item = 0xFF;
	State = 0;
	Flag = 1;
	Flag1 = 0;
	Flag2 = 0;
	/************* C[v  **************/
	while(1)
	{
		/*** \ **/
		if(Flag){							// \v`FbN
			Display();						// \o
			Flag = 0;						// vtONA
		}
		/** XCb``FbN **/
		if((GPIO4 == 0)||(GPIO5==0)){			// XCb`IH
			Process();						// XCb`̏
			while((GPIO4==0)||(GPIO5==0));		// `b^O
			__delay_ms(40);
		}					
	}
}
/*****************************************
*  XCb`  Xe[g֐Ƃē
*  SW1:ڑIAԐݒ
*  SW2FEnterŌ
*  StateFXe[gϐ
*@@0FڑI@@1FԐݒ
*    2FJnor߂@5FuU[~
*****************************************/
void Process(void){
	switch(State){
		case 0: 		/*** ڑI ***/
			if(GPIO4 == 0){					// SW1I
				Item++;						// ڂ
				if(Item > 3)
					Item = 0;				// ŏɖ߂
				Cursor(Item);					// J[\uN
			}
			if(GPIO5 == 0)					// SW2I
				State++;						// II
			break;
		case 1:		/*** Ԑݒ **/
			if(GPIO4 == 0){					// SW1I
				switch(Item){				// w荀ڂ̎ԍXV
					case 0:
						if(Min1 > 29)			// ^C}P@
							Min1 = 0;
						else
							Min1++;
						break;
					case 1:					// ^C}P@b
						if(Sec1 >= 60)
							Sec1 = 0;
						else
							Sec1 += 10;		// 10bP
						break;
					case 2:					// ^C}Q@
						if(Min2 > 29)
							Min2 = 0;
						else
							Min2++;
						break;
					case 3:					// ^C}Q@b
						if(Sec2 >= 60)
							Sec2 = 0;
						else
							Sec2 += 10;		// 10bP
						break;
					default: break;
				}
				Display();					// ԕ\
			}
			if(GPIO5 == 0)					// SW2
				State++;						// m@
			break;
		case 2:		/**** ^C}X^[gڑI ***/
			if(GPIO4 == 0){					// SW1Ȃ߂
				State = 0;					// ڑI֖߂
				Cursor(Item);					// J[\\
			}
			if(GPIO5 == 0){					// SW2ȂX^[g
				if((Min1 != 0) || (Sec1 != 0))	// ^C}PX^[g
					Flag1 = 1;
				if((Min2 != 0) || (Sec2 != 0))	// ^C}QX^[g
					Flag2 = 1;
				if((Flag1)||(Flag2))			// ꂩJnH
					TMR1ON = 1;				// Timer1X^[g
				State = 0;					// ڑI
			}
			break;
		case 5:		/*** uU[~Xe[g ***/
			Buzzer(0);						// uU[~
			State = 0;						// ڑI
			break;
		default: break;			
	}
}
/***************************************
*  J[\ړ
***************************************/
void Cursor(unsigned char item){
	/** J[\ʒuړ **/
	switch(item){
		case 0: lcd_cmd(0x87); break;
		case 1: lcd_cmd(0x8A); break;
		case 2: lcd_cmd(0xC7); break;
		case 3: lcd_cmd(0xCA); break;
		default: break;
	}
	lcd_cmd(0x0F);					// uNI
}

/****************************************
*  Timer1荞ݏ
*  Timer1F1b
*****************************************/
void interrupt T1ISR(void){
	/**** b^C} Timer1 荞ݏ ****/
	TMR1H = 0x85;						// TMR1ʃZbg
	TMR1L = 0xF0;						// TMR1ʃZbg
	TMR1IF = 0;						// 荞݃tONA
	Flag = 1;						// \vI
	GPIO2 = 1;						// `bNI
	/*** ^C}P ***/
	if(Flag1){						// ^C}PIH
		if(Sec1 == 0){				// bIH
			if(Min1 > 0){				// IH
				Sec1 = 59;			// 59bɍăZbg
				Min1--;				// 
			}
			else{
				Buzzer(1);			// uU[I
				Flag1 = 0;			// ^C}PIt
				State = 5;
			}
		}
		else
			Sec1--;					// b
	}
	/*** ^C}Q ***/
	if(Flag2){						// ^C}QIH
		if(Sec2 == 0){				// bIH
			if(Min2 > 0){				// IH
				Sec2 = 59;			// bĐݒ
				Min2--;				// 
			}
			else{
				Buzzer(2);			// uU[I
				Flag2 = 0;			// ^C}QIt
				State = 5;			// uU[~Xe[g
			}
		}
		else
			Sec2--;					// b
	}
	GPIO2 = 0;						// `bNIt
	/*** ^C}ItmF ***/
	if((Flag1==0) && (Flag2==0))
		TMR1ON = 0;					// Timer1~
}
/*************************************
*  \
*************************************/
void Display(void){
	/*** ^C}P\ ***/
	if(Flag1){
		lcd_cmd(0x80);				// 1s
		itostring(2, Min1, Msg1+7);	// ϊ
		itostring(2, Sec1, Msg1+10);	// bϊ
		Msg1[14] = 'n';				// On\
		Msg1[15] = ' ';
		lcd_str(Msg1);				// \o
	}
	else{
		lcd_cmd(0x80);				// 1s
		itostring(2, Min1, Msg1+7);	// ϊ
		itostring(2, Sec1, Msg1+10);	// bϊ
		Msg1[14] = 'f';				// Off\
		Msg1[15] = 'f';
		lcd_str(Msg1);
	}
	/*** ^C}Q\ ***/
	if(Flag2){
		lcd_cmd(0xC0);				// 2s
		itostring(2, Min2, Msg2+7);	// ϊ
		itostring(2, Sec2, Msg2+10);	// bϊ
		Msg2[14] = 'n';				// On\
		Msg2[15] = ' ';
		lcd_str(Msg2);				// \o
	}
	else{
		lcd_cmd(0xC0);				// 2s
		itostring(2, Min2, Msg2+7);	// ϊ
		itostring(2, Sec2, Msg2+10);	// bϊ
		Msg2[14] = 'f';				// Off\
		Msg2[15] = 'f';
		lcd_str(Msg2);
	}
}
/***************************************
* intASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
		buffer--;					// |C^[P
		*buffer = (data % 10) + '0';	// ASCII
		data = data / 10;				// ̌
	}
}
/******************************************
* uU[
*  CCP1PWM[hŏo f[eB50%
******************************************/
void Buzzer(unsigned cont){
	switch(cont){
		case 0:						// uU[~
			T2CON = 0;				// Timer2~
			CCP1CON = 0;				// PWM~
			break;
		case 1:
			/* Timer2ݒ@4kHz */
			PR2 = 61;				// 4usec*62=0.25msec
			TMR2 = 0;
			T2CON = 0x04;				// Timer2X^[g
			CCP1CON = 0x0C;			// PWM[h
			CCPR1L = 31;				// Duty 50%
			State = 5;				// uU[~Xe[g
			break;
		case 2:
			/* Timer2ݒ@3kHz */
			PR2 = 81;				// 4usec*82=0.33msec
			TMR2 = 0;
			T2CON = 0x04;				// Timer2X^[g
			CCP1CON = 0x0C;			// PWM[h
			CCPR1L = 41;				// Duty 50%
			State = 5;				// uU[~Xe[g
			break;
		default : break;
	}
}

	